﻿namespace TabsStudioOrderKeeper
{
    class OpenDocumentsAdapter : IOpenDocuments
    {
        public OpenDocumentsAdapter(TabsStudioCommon.OpenDocuments openDocuments)
        {
            this.openDocuments = openDocuments;
        }

        public string FindDocument(TabsStudioExt.TabExtension extension)
        {
            return openDocuments.FindDocument(extension.Window).document;
        }

        public System.Collections.Generic.List<string> FindDocuments(TabsStudioExt.Tab tab)
        {
            System.Collections.Generic.List<TabsStudioCommon.WindowDocument> documents =
                openDocuments.FindDocuments(tab.TabItem);
            if (documents == null)
                return null;

            System.Collections.Generic.List<string> result = new System.Collections.Generic.List<string>();
            foreach (TabsStudioCommon.WindowDocument i in documents)
                result.Add(i.document);
            return result;
        }

        private TabsStudioCommon.OpenDocuments openDocuments;
    }
}
