﻿namespace UnitTestProject
{
    class OpenDocumentsMock : TabsStudioOrderKeeper.IOpenDocuments
    {
        public OpenDocumentsMock()
        {
            docs = new System.Collections.Generic.Dictionary<TabsStudioExt.TabExtension, string>();
        }

        // IOpenDocuments:

        public string FindDocument(TabsStudioExt.TabExtension extension)
        {
            return docs[extension];
        }

        public System.Collections.Generic.List<string> FindDocuments(TabsStudioExt.Tab tab)
        {
            System.Collections.Generic.List<string> result = new System.Collections.Generic.List<string>();
            foreach (TabsStudioExt.TabExtension i in tab.TabExtensions)
                result.Add(FindDocument(i));
            return result;
        }

        //

        public void AddExtension(TabsStudioExt.TabExtension extension, string document)
        {
            docs.Add(extension, document);
        }

        public void RemoveExtension(TabsStudioExt.TabExtension extension)
        {
            docs.Remove(extension);
        }

        private System.Collections.Generic.Dictionary<TabsStudioExt.TabExtension, string> docs;
    }
}
