﻿namespace UnitTestProject
{
    class Tabs
    {
        public Tabs(OpenDocumentsMock docs)
        {
            this.docs = docs;
            tabList = new System.Collections.Generic.List<TabsStudioExt.Tab>();
            panel = new System.Windows.Controls.StackPanel();
            tabs = new TabsStudioExt.Tabs(panel, tabList, true);
        }

        public void Open(string title)
        {
            System.Windows.Controls.TabItem tabItem = new System.Windows.Controls.TabItem();
            tabItem.Header = title;
            TabsStudioExt.TabExtension tabExtension = new
                TabsStudioExt.TabExtension(null, false, null, null);
            System.Collections.Generic.List<TabsStudioExt.TabExtension> tabExtensions = new
                System.Collections.Generic.List<TabsStudioExt.TabExtension>();
            tabExtensions.Add(tabExtension);
            TabsStudioExt.Tab tab = new TabsStudioExt.Tab(tabItem, tabExtensions, false, false, null);
            tabList.Add(tab);
            panel.Children.Add(tabItem);

            docs.AddExtension(tabExtension, title);
        }

        public void Close(int index)
        {
            TabsStudioExt.Tab tab = FindTab(index);
            foreach (TabsStudioExt.TabExtension i in tab.TabExtensions)
                docs.RemoveExtension(i);
            tabList.Remove(tab);
            panel.Children.RemoveAt(index);
        }

        public TabsStudioExt.TabExtensionEventArgs GetExtensionArgs(int tabIndex, int extensionIndex)
        {
            TabsStudioExt.Tab tab = FindTab(tabIndex);
            return new TabsStudioExt.TabExtensionEventArgs(tabs, tab, tab.TabExtensions[extensionIndex]);
        }

        public int GetCount()
        {
            return panel.Children.Count;
        }

        public string GetTitle(int index)
        {
            System.Windows.Controls.TabItem tabItem = panel.Children[index] as System.Windows.Controls.TabItem;
            return tabItem.Header as string;
        }

        public void Move(int source, int target)
        {
            System.Windows.Controls.TabItem tabItem = panel.Children[source] as System.Windows.Controls.TabItem;
            panel.Children.Remove(tabItem);
            panel.Children.Insert(target, tabItem);
        }

        private TabsStudioExt.Tab FindTab(int tabIndex)
        {
            System.Windows.Controls.TabItem tabItem = panel.Children[tabIndex] as System.Windows.Controls.TabItem;
            foreach (TabsStudioExt.Tab tab in tabList)
            {
                if (tab.TabItem == tabItem)
                    return tab;
            }
            return null;
        }

        private OpenDocumentsMock docs;
        private System.Collections.Generic.List<TabsStudioExt.Tab> tabList;
        private System.Windows.Controls.Panel panel;
        private TabsStudioExt.Tabs tabs;
    }
}
